; Script to implement Conbagui Tutorial on Gimpchat (see Stained Glass Text topic)
;
; Flow implemented to get the final result:
; 
; *** STEP 1A background	
	;prepare the BG but do not fill it until the size is properly adjusted
; *** STEP 1B text layer		
 	;create the stained-glass-text layer
; *** STEP 2  grow the selection
; *** STEP 3A duplicate the text layer and set both invisible
; *** STEP 3B select none in the text layer 
; *** added step: adjust image size	
	;NOTE! image size has to be adjusted to the created text size 
	;(script does not use a fixed size, BUT A DYNAMIC ONE based on entered text)	
; *** STEP 4  drop shadow on the text layer 
; *** STEP 5  inner shadow on the text layer 
; *** STEP 6A inner glow on the text layer 
;             note: not possible to set the gradient, used colour...
; *** STEP 6B ...then added gradient overlay on the layer 
; *** STEP 7  stroke the text layer	
; *** STEP 8A select the stroke layer
; *** STEP 8B emboss the stroke layer 
; *** STEP 9  overlay the text layer with the selected glass pattern
; *** STEP 10A select the pattern layer	
; *** STEP 10B emboss the pattern layer	
; *** STEP 11  satin on the top layer (duplicated text layer)
; *** STEP 12  gradient overlay on the top layer (duplicated text layer)	
		
; ----------------------------------------------------------------
; ----------------------------------------------------------------
; 
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 3 of the License, or
; (at your option) any later version.  
; 
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
; 
; You should have received a copy of the GNU General Public License
; along with this program; if not, you can view the GNU General Public
; License version 3 at the web site http://www.gnu.org/licenses/gpl-3.0.html
; Alternatively you can write to the Free Software Foundation, Inc., 675 Mass
; Ave, Cambridge, MA 02139, USA.
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; 
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
   
(define (script-fu-stained-glass-txt2
				theText
				textSize
				textFont
				strokeColor
				theBackgroundPattern
				theGlassPattern
				theGlassTexture
				theStrokeTexture
				theGlassGradient
				doFlatten
	)


; Variable init
  (let* 
    (
	(imageWidth 400)
	(imageHeight 200)
	(textSpacing)
	(theNewImage (car (gimp-image-new imageWidth imageHeight RGB)))
	(theBackgroundLayer)
	(theGlassLayer)
	(theDupGlassLayer)
	(theStrokeLayer)
	(thePatternLayer)
	(theMergedLayer)
	(theDisplay)
    )

    (gimp-message-set-handler 2)
; Initialize an undo, so the process can be undone with a single undo
    (gimp-image-undo-group-start theNewImage)
	
	(gimp-context-set-foreground '(0 0 0))
	(gimp-context-set-background '(255 255 255))
	
; *** STEP 1A background	
	;prepare the BG but do not fill it until the size is properly adjusted
    (set! theBackgroundLayer (car (gimp-layer-new theNewImage imageWidth imageHeight
	                           RGBA-IMAGE "Wall" 100 NORMAL-MODE)))
	(gimp-image-insert-layer theNewImage theBackgroundLayer 0 0)
; *** STEP 1B text layer		
 	;create the stained-glass-text layer
    (set! theGlassLayer (car (gimp-text-fontname theNewImage -1 0 0 
	                     theText 10 TRUE textSize PIXELS textFont)))
	(set! textSpacing (/ textSize 7))					 
	(gimp-item-set-name theGlassLayer "VITRO") ; to know the name of all subsequent layers created by layerfx
	(gimp-text-layer-set-letter-spacing theGlassLayer textSpacing)
	(gimp-text-layer-set-line-spacing theGlassLayer textSpacing)    ; Set Line Spacing
    (gimp-text-layer-set-justification theGlassLayer TEXT-JUSTIFY-CENTER)  ; Text Jusification 
; *** STEP 2  grow the selection
	(gimp-selection-grow theNewImage 15)	
	(gimp-image-select-item theNewImage CHANNEL-OP-ADD theGlassLayer)
	(gimp-edit-fill theGlassLayer FOREGROUND-FILL) ;fill the extended areas
; *** STEP 3A duplicate the text layer and set both invisible	
	(set! theDupGlassLayer (car (gimp-layer-new-from-drawable theGlassLayer theNewImage)))
	(gimp-image-insert-layer theNewImage theDupGlassLayer 0 -1)
	(gimp-item-set-visible theGlassLayer FALSE)
	(gimp-item-set-visible theDupGlassLayer FALSE)
; *** STEP 3B select none in the text layer 
	(gimp-image-set-active-layer theNewImage theGlassLayer)
	(gimp-selection-none theNewImage)
; *** added step: adjust image size	
	;NOTE! image size has to be adjusted to the created text size (script does not use a fixed size)
	(gimp-image-resize-to-layers theNewImage)
	(set! imageWidth (car (gimp-image-width theNewImage)))  	;update
	(set! imageWidth (+ imageWidth (* 2 textSpacing)))
	(set! imageHeight (car (gimp-image-height theNewImage)))    ;update
;(gimp-message (number->string imageHeight))
	(set! imageHeight (+ imageHeight (* 2 textSpacing)))
;(gimp-message (number->string imageHeight))
	(gimp-image-resize theNewImage imageWidth imageHeight textSpacing textSpacing)
	(gimp-layer-resize-to-image-size theGlassLayer)				;update
	(gimp-layer-resize-to-image-size theDupGlassLayer)			;update
	(gimp-layer-resize-to-image-size theBackgroundLayer)		;update
; >>>  now fill the BG, size has been properly adjusted
    (gimp-image-set-active-layer theNewImage theBackgroundLayer)
	(gimp-context-set-pattern theBackgroundPattern)
	(gimp-edit-fill theBackgroundLayer PATTERN-FILL)
; >>> restore the active layer	
	(gimp-image-set-active-layer theNewImage theGlassLayer)
; *** STEP 4  drop shadow on the text layer 
	(python-layerfx-drop-shadow RUN-NONINTERACTIVE
			theNewImage theGlassLayer '(0 0 0) 100 0 0 MULTIPLY-MODE 8 14 120 20 TRUE FALSE)
; *** STEP 5  inner shadow on the text layer			
	(python-layerfx-inner-shadow RUN-NONINTERACTIVE
			theNewImage theGlassLayer '(0 0 0) 62 0 0 SOFTLIGHT-MODE 0 4 12 120 12 FALSE)
; *** STEP 6A inner glow on the text layer (note: not possible to set the gradient, used colour)			
	(python-layerfx-inner-glow RUN-NONINTERACTIVE
			theNewImage theGlassLayer '(200 200 100) 50 1 0 DODGE-MODE 0 5 27 FALSE)
; *** STEP 6B ...then added gradient overlay on the layer 			
	(python-layerfx-gradient-overlay RUN-NONINTERACTIVE
	        theNewImage theGlassLayer theGlassGradient 
			GRADIENT-LINEAR REPEAT-TRIANGULAR FALSE 50 OVERLAY-MODE
			0.0 0.0 90 100 FALSE)
; *** STEP 7  stroke the text layer			
	;(define CGP (list 3 64 3)) ; define the list for a colour or gradient or pattern: DARK GREEN
	(python-layerfx-stroke RUN-NONINTERACTIVE
			theNewImage theGlassLayer strokeColor 100 NORMAL-MODE 10 100 FALSE) ; does not take the pattern, only a color!!!
; *** STEP 8A select the stroke layer			
	(set! theStrokeLayer (car(gimp-image-get-layer-by-name theNewImage "VITRO-stroke")))	
;(gimp-message (number->string theStrokeLayer))
	(gimp-image-set-active-layer theNewImage theStrokeLayer)
; *** STEP 8B emboss the stroke layer    	
	(python-layerfx-bevel-emboss RUN-NONINTERACTIVE
	        theNewImage theStrokeLayer 2 65 1 15 5 120 30 0
			'(255 255 255) OVERLAY-MODE 66 '(0 0 0) MULTIPLY-MODE 62 6 TRUE
			theStrokeTexture 100 100 FALSE FALSE)	
; *** STEP 9  overlay the text layer with the selected glass pattern
    (gimp-image-set-active-layer theNewImage theGlassLayer)	
	(gimp-image-select-item theNewImage CHANNEL-OP-ADD theGlassLayer)	;alpha to selection
	(gimp-context-set-pattern theGlassPattern)
    (python-layerfx-pattern-overlay RUN-NONINTERACTIVE
			theNewImage theGlassLayer theGlassPattern 100 NORMAL-MODE 50 0 0)
; *** STEP 10A select the pattern layer
	(set! thePatternLayer (car(gimp-image-get-layer-by-name theNewImage "VITRO-pattern")))	
;(gimp-message (number->string theStrokeLayer))
	(gimp-image-set-active-layer theNewImage thePatternLayer)				
; *** STEP 10B emboss the pattern layer    	
	(python-layerfx-bevel-emboss RUN-NONINTERACTIVE
	        theNewImage thePatternLayer 1 65 1 9 9 120 30 0
			'(255 255 255) DODGE-MODE 75 '(0 0 0) OVERLAY-MODE 45 6 TRUE
			theGlassTexture 150 50 FALSE FALSE)			
; *** STEP 11  satin on the top layer (duplicated text layer)
	(gimp-image-set-active-layer theNewImage theDupGlassLayer)
	(python-layerfx-satin RUN-NONINTERACTIVE
	        theNewImage theDupGlassLayer '(255 255 255) 75 SOFTLIGHT-MODE 8 20 20 5.5 TRUE FALSE)
; *** STEP 12  gradient overlay on the top layer (duplicated text layer)			
	(python-layerfx-gradient-overlay RUN-NONINTERACTIVE
	        theNewImage theDupGlassLayer theGlassGradient 
			GRADIENT-LINEAR REPEAT-TRIANGULAR FALSE 30 OVERLAY-MODE
			0.0 0.0 90 100 FALSE)
						
; ***************************   FINAL OUTPUT ***************************************************	
	(set! theDisplay (car (gimp-display-new theNewImage)))
   
	(if (= doFlatten TRUE)
		(gimp-image-flatten theNewImage)
		)
    (gimp-selection-none theNewImage)
    ;Ensure the updated image is displayed now
    (gimp-displays-flush)

    (gimp-image-undo-group-end theNewImage)
)
)

(script-fu-register "script-fu-stained-glass-txt2"
            _"<Image>/File/Create/Logos/Stained Glass Logo..."
            "Write a text with a stained glass appearance"
            "Diego Nassetti"
            "Diego Nassetti"
            "26/05/2014"
            ""
            SF-TEXT	    	_"Text"               "VITRO"
		    SF-ADJUSTMENT 	_"Font size (pixels)" '(350 15 350 1 1 0 1)
		    SF-FONT       	_"Font"               "Phantom Lord Lite"
			SF-COLOR        _"Stroke color"       '(43 37 29)
            SF-PATTERN      _"Background Pattern" "Rough Wall.jpg" ;select a Pattern for the background
			SF-PATTERN      _"Glass Pattern"      "Vitro" ;select a Pattern for the glass text
			SF-PATTERN      _"Glass Texture"	  "Frosted Glass texture.jpg"  ;select a texture for the glass pattern
			SF-PATTERN      _"Stroke Texture"	  "3D Brown texture pattern.jpg"  ;select a texture for the stroke contour
			SF-GRADIENT		_"Glass Gradient"	  "Candle"  ; select a gradient for the glass text	
			SF-TOGGLE       _"Flatten Image"	  TRUE
)

