;; 
;; ---------------------------------------------------------
;; *							   
;; * 		  	    Script-Fu Safari 2.6v2
;; *							   
;; ---------------------------------------------------------
;; creative commons licence
;; http://creativecommons.org/licenses/by-nc-sa/2.0/fr/
;;special thanks to monsoonami for the colors(hue)animation option



(define (apply-safari-2.6 image drawable 
                                                    txt-layer
                                                    bkg-layer
                                                    type 
                                                    relief 
                                                    camo
                                                    gradient
                                                    light 
                                                    shadow 
                                                    blur
                                                    elevation
                                                    outline 
                                                    conserv)
 	
	(let* (			
		;; know the dimensions of the image
		(image-width (car (gimp-drawable-width txt-layer)))
		(image-height (car (gimp-drawable-height txt-layer)))
		
		(final-image (car (gimp-image-new image-width image-height RGB)))
		
		(texture-terra-image 0)
		(texture-blueweb-image 0)
		(texture-safari-image 0)
		(texture-terra-layer 0)
		(texture-blueweb-layer 0)
		(texture-safari-layer 0)
		(bump-image 0)
		(bump-layer 0)
		(duplicate-layer 0)
		(shadow-layer 0)
		(mask 0)
		(brushName    "outlineBrush")
		(text-layer (car (gimp-layer-new-from-drawable txt-layer final-image)))
           (background-layer (car (gimp-layer-new-from-drawable bkg-layer final-image)))
		(fond-map-layer 0) ;; map pour le relief
           (activeLayer 0)
           (gradient-layer)         
		)
		(gimp-context-push)
		
		;; *******************************************************************************
		;; FINAL LAYER PREPARATION
		;; *******************************************************************************
		;; add layer
		(if (> shadow 0) ;; si un shadow est demandé
			(begin
				(set! shadow-layer (car (gimp-layer-new final-image image-width image-height RGBA-IMAGE "shadow" 100 NORMAL-MODE)))
				(gimp-image-add-layer final-image shadow-layer -1)
				(gimp-edit-clear shadow-layer)	
			)
		)
		 (gimp-image-add-layer final-image background-layer -1)
           (gimp-drawable-set-name background-layer "Background")
           (gimp-layer-set-offsets background-layer 0 0) ;; add the coordinates to the layer 
           (gimp-image-add-layer final-image text-layer -1)
		(gimp-drawable-set-name text-layer "Script-fu Safari")
		(gimp-layer-set-offsets text-layer 0 0) ;; add the coordinates to the layer 
		(gimp-context-set-foreground '(255 255 255));;white
		(gimp-layer-set-preserve-trans text-layer 1) ;; preserve transparency
		(gimp-edit-fill text-layer 0) ;; fill with white

		;; *******************************************************************************
		;; MAP
		;; *******************************************************************************
		;; duplicate text-layer to create the map
		(set! bump-image (car (gimp-image-duplicate final-image)))
		(set! fond-map-layer (car (gimp-layer-new bump-image image-width image-height RGB-IMAGE "Carte" 100 NORMAL-MODE))) ;; map pour le relief
		(gimp-context-set-foreground '(0 0 0));;black
		(gimp-image-add-layer bump-image fond-map-layer 1)
		(gimp-edit-fill fond-map-layer 0) ;; fill with black
		(set! bump-layer (car (gimp-image-flatten bump-image))) ;; flatten the image map
		(plug-in-gauss-rle2 RUN-NONINTERACTIVE bump-image bump-layer blur blur) ;;  gaussien blur image map
		
		;; *******************************************************************************
		;; REPOUSSAGE
		;; *******************************************************************************
		(plug-in-bump-map 1 final-image text-layer bump-layer 135 elevation 3 0 0 0 0 TRUE FALSE 0) ;; 
				
		;; *******************************************************************************
		;; TYPE OF EFFECT
		;; *******************************************************************************
		;; base
		(if (= camo 0) ;;user select
			(begin
           (gimp-context-set-gradient gradient)
                )
           )
           (if (= camo 1) ;;desert 
			(begin
           (gimp-context-set-gradient "Shadows 1")
                )
           )
           (if (= camo 2) ;;jungle 
			(begin
           (gimp-context-set-gradient "Greens")
                )
           )
           (if (= camo 3) ;;urban 
			(begin
           (gimp-context-set-gradient "Four bars")
                )
           )
           (gimp-drawable-set-name bkg-layer (car (gimp-context-get-gradient)))

		(if (= relief 1) ;; relief double
			(begin
				(plug-in-displace RUN-NONINTERACTIVE final-image text-layer 50 50 TRUE TRUE bump-layer bump-layer 0)
			)
		)
		(if (> shadow 0) ;; if a shadow is requested
			(begin
				(gimp-selection-layer-alpha text-layer) ;; alpha vers selection
				(gimp-edit-fill shadow-layer FOREGROUND-FILL) ;; fill with black
				(gimp-selection-none final-image)
				(plug-in-gauss-rle2 RUN-NONINTERACTIVE final-image shadow-layer shadow shadow) ;; shadow gaussien
                     (gimp-layer-translate shadow-layer shadow shadow);;shadow-layer offset
			)
		)
		;; texture terra
		(set! texture-terra-image (car (gimp-image-new image-width image-height RGB)))
		(set! texture-terra-layer (car (gimp-layer-new texture-terra-image image-width image-height RGB "Pattern Terra" 100 NORMAL-MODE)))
		(gimp-image-add-layer texture-terra-image texture-terra-layer -1)
		(gimp-context-set-pattern "Terra")
		(gimp-edit-fill texture-terra-layer PATTERN-FILL)
		;; texture blue web
		(set! texture-blueweb-image (car (gimp-image-new image-width image-height RGB)))
		(set! texture-blueweb-layer (car (gimp-layer-new texture-blueweb-image image-width image-height RGB "Pattern Blue Web" 100 NORMAL-MODE)))
		(gimp-image-add-layer texture-blueweb-image texture-blueweb-layer -1)
		(gimp-context-set-pattern "Blue Web")
		(gimp-edit-fill texture-blueweb-layer PATTERN-FILL)
		;; texture safari
		(set! texture-safari-image (car (gimp-image-new image-width image-height RGB)))
		(set! texture-safari-layer (car (gimp-layer-new texture-safari-image image-width image-height RGB "Texture Safari" 100 NORMAL-MODE)))
		(gimp-image-add-layer texture-safari-image texture-safari-layer -1)
		(plug-in-solid-noise RUN-NONINTERACTIVE texture-safari-image texture-safari-layer FALSE FALSE 0 1 4.0 4.0)
		(plug-in-displace RUN-NONINTERACTIVE texture-safari-image texture-safari-layer 20 20 TRUE TRUE texture-blueweb-layer texture-blueweb-layer 0)
		(plug-in-oilify RUN-NONINTERACTIVE texture-safari-image texture-safari-layer 8 1)
           (gimp-context-set-foreground '(0 255 0));;green
           (gimp-context-set-background '(0 127 0));;khaki
		(plug-in-gradmap RUN-NONINTERACTIVE texture-safari-image texture-safari-layer) ;; apply the gradient
		(plug-in-displace RUN-NONINTERACTIVE texture-safari-image texture-safari-layer 10 10 TRUE TRUE texture-terra-layer texture-terra-layer 0)
		
		(if (= type 1) ;; wild
			(begin
				(plug-in-spread RUN-NONINTERACTIVE texture-safari-image texture-safari-layer 20 20)
			)
		)
		(if (= type 2) ;; deep cover
			(begin
				(plug-in-cartoon RUN-NONINTERACTIVE texture-safari-image texture-safari-layer 7.0 0.200)
			)
		)
		(if (= type 3) ;; reptilian
			(begin
				(plug-in-mosaic RUN-NONINTERACTIVE texture-safari-image texture-safari-layer 15.0 4.0 1.0 0.65 TRUE 135.0 0.2 TRUE FALSE 1 FALSE FALSE)
			)
		)
		(if (= type 4) ;; peacefull
			(begin
				(plug-in-polar-coords RUN-NONINTERACTIVE texture-safari-image texture-safari-layer 100.0 0.0 FALSE TRUE FALSE)
			)
		)
		
		(set! duplicate-layer (car (gimp-layer-new-from-drawable texture-safari-layer final-image)))
		(gimp-image-add-layer final-image duplicate-layer -1)
		(gimp-layer-set-mode duplicate-layer MULTIPLY-MODE)
           ;; Lighting levels
		(if (> light 0)
			(begin
				(if (= light 1) (gimp-levels duplicate-layer HISTOGRAM-VALUE 0 255 0.5 0 255))
                     (if (= light 2) (gimp-levels duplicate-layer HISTOGRAM-VALUE 0 255 1.3 0 255))
				(if (= light 3) (gimp-levels duplicate-layer HISTOGRAM-VALUE 0 255 1.7 0 255))
				(if (= light 4) (gimp-levels duplicate-layer HISTOGRAM-VALUE 0 255 2.2 0 255))                   				     )
		)

		(if (> shadow 0) ;; if a shadow is requested
			(begin
				(set! mask (car (gimp-layer-create-mask duplicate-layer ADD-BLACK-MASK)))
				(gimp-layer-add-mask duplicate-layer mask)
				(gimp-context-set-foreground '(255 255 255))
				(gimp-selection-layer-alpha text-layer) ;; alpha to selection
				(gimp-edit-fill mask FOREGROUND-FILL) ;; fill with black
				(gimp-selection-none final-image)
                      
			)
		)		

		
		;; *******************************************************************************
		;; FINALISATIONS
		;; *******************************************************************************
		
		(gimp-image-delete texture-terra-image)
		(gimp-image-delete texture-blueweb-image)
           (gimp-image-delete texture-safari-image)
           (gimp-image-delete bump-image)
           
           ;;Outline the text or Image
            (gimp-image-set-active-layer final-image text-layer)           
            (gimp-selection-layer-alpha text-layer) ;; Alpha to Selection
            (gimp-selection-invert final-image);;invert selection
           ;; define new brush for drawing operation
            (gimp-brush-new brushName)
            (gimp-brush-set-shape brushName BRUSH-GENERATED-CIRCLE)    
            (gimp-brush-set-spikes brushName 2)
            (gimp-brush-set-hardness brushName 1.00)                   
            (gimp-brush-set-aspect-ratio brushName 1.0)
            (gimp-brush-set-angle brushName 0.0)                       
            (gimp-brush-set-spacing brushName 1.0)
            (gimp-brush-set-radius brushName outline)            
            (gimp-context-set-brush brushName)
            (gimp-context-set-foreground '(0 0 0));;black 
            (gimp-edit-stroke text-layer);;stroke the selection
            (gimp-selection-none final-image)
            (gimp-brush-delete brushName)
          
         (gimp-image-lower-layer-to-bottom final-image background-layer)
         		(if (= conserv FALSE) ;; Conserve the layers ?
			    (begin
                     (gimp-drawable-set-name background-layer gradient)
				(gimp-image-merge-visible-layers final-image CLIP-TO-IMAGE)
                     (set! activeLayer (car (gimp-image-get-active-layer final-image)))
                     (set! gradient-layer (car (gimp-layer-new-from-drawable activeLayer image)))
		          (gimp-image-add-layer image gradient-layer -1)
                     (gimp-image-delete final-image)                                          
			   )
		    )
               (if (= conserv TRUE) ;; Conserve the layers ?
			   (begin                     
                     (gimp-display-new final-image)                     
                   )
               )
		
          (gimp-displays-flush)	

		;; update		
		(gimp-context-pop)
	)
)






;; ------------------------
;; script for the <image> 
;; ------------------------

(define (script-fu-safari-2.6 image drawable 
                                                        text-layer 
                                                        bkg-layer 
                                                        type 
                                                        relief 
                                                        camo
                                                        gradient 
                                                        light 
                                                        shadow 
                                                        blur
                                                        elevation
                                                        outline 
                                                        conserv)
	(let* (
		(var-select (car (gimp-selection-is-empty image)))
		(canal 0)
		)

  		(gimp-image-undo-group-start image)
    		
		
		(if (= var-select TRUE) ;; test if there is a selection
			(begin ;; no selection was made
			)
			(begin ;; a selection was made
				(set! canal (car (gimp-selection-save image))) ;; channel storing the user's original selection
			)
		)
		
		(gimp-selection-none image)

		(apply-safari-2.6 image drawable 
                                                       text-layer 
                                                       bkg-layer 
                                                       type 
                                                       relief 
                                                       camo
                                                       gradient 
                                                       light 
                                                       shadow  
                                                       blur
                                                       elevation
                                                       outline 
                                                       conserv)
    		
		(if (= var-select TRUE) ;; test if there is a selection
			(begin ;; no selection was made
			)
			(begin ;; a selection was made(return the user selection)
				(gimp-selection-load canal) ;; channel mask to selection
				(gimp-image-remove-channel image canal) ;; remove the mask channel
			)
		)
		
		(gimp-image-undo-group-end image)
    		
		(gimp-displays-flush)		
	)
)

(script-fu-register "script-fu-safari-2.6"
		"Safari..."
		"Camoflage types."
		"Graechan"
		"Graechan"
		"03/09/2011"
		"RGBA"
        SF-IMAGE "Image" 0
        SF-DRAWABLE "Drawable" 0
           SF-LAYER      "Warstwa tekstu lub obraz" 0                     
           SF-LAYER      "Tło" 0
		SF-OPTION     "Typ" '("Quiet" "Wild" "Deep Cover" "Reptilian" "Peacefull")
		SF-OPTION     "Wypukłość" '("Simple" "Double")
		SF-OPTION     "Camouflage Setting" '("User Defined Gradient" "Desert" "Jungle" "Urban")
           SF-GRADIENT   "User Gradient" "Blinds"
		SF-OPTION     "Intensywność światła" '("No Change""Dim" "Soft" "Medium" "Intense")
           SF-ADJUSTMENT "Cień" '(5 1 15 1 10 0 1)
		SF-ADJUSTMENT "Rozmycie(Bumpmap)" '(30 1 120 1 0 0 1);;was 15
		SF-ADJUSTMENT "Elevation(Bumpmap)" '(20 1 90 1 0 0 1)	
           SF-ADJUSTMENT "Outline Size(0=no outline)" '(0 0 5 1 0 0 1)	
		SF-TOGGLE     "Zachować warstwy ?" FALSE
)

(script-fu-menu-register "script-fu-safari-2.6" "<Image>/Filters/Alpha to Logo/")


(define (script-fu-safari-2.6-logo 
                                      text                                       
                                      font 
                                      size
                                      bkg-type 
                                      pattern
                                      bkg-color
                                      animate
                                      frames
                                      type 
                                      relief 
                                      camo
                                      gradient
                                      light 
                                      shadow 
                                      blur
                                      elevation
                                      outline 
                                      conserv)

  (let* ((image (car (gimp-image-new 256 256 RGB)))
         (border (/ size 4))
         (txt-layer (car (gimp-text-fontname image -1 0 0 text border TRUE size PIXELS font)))
         (text-width (car (gimp-drawable-width txt-layer)))
         (text-height (car (gimp-drawable-height txt-layer)))
         (bkg-layer 0)
         (safari 0)
         (list 0)
         (name 0)
         (activeLayer 0)         
         )
    (gimp-context-push)    
    (gimp-context-set-foreground '(0 0 0))
    (set! bkg-layer (car (gimp-layer-new image text-width text-height RGBA-IMAGE gradient 100 NORMAL-MODE)))
    (if (= bkg-type 1)
		(begin
    (gimp-context-set-pattern pattern)
    (gimp-drawable-fill bkg-layer PATTERN-FILL)
           )
    )
    (if (= bkg-type 2)
		(begin
    (gimp-context-set-background bkg-color)
    (gimp-drawable-fill bkg-layer BACKGROUND-FILL)
           )
    )

    (gimp-image-add-layer image bkg-layer 1)
    (gimp-image-resize-to-layers image)
    (gimp-image-set-active-layer image txt-layer)
    
    (gimp-context-pop)
    
    (gimp-image-undo-disable image)
    (if (= animate 0)
		(begin
    (apply-safari-2.6 image txt-layer txt-layer bkg-layer type relief camo gradient light shadow blur elevation outline conserv)
    (gimp-image-merge-visible-layers image CLIP-TO-IMAGE)
           )
    )
    (if (= animate 1)
	(begin
           (set! camo 0)
           (set! conserv FALSE)
           (gimp-display-new image)
           (set! list (cadr (gimp-gradients-get-list "")))           
		(while (and (not (null? list)) (> frames 0)) 
            	(set! name (car list));;(gimp-message name)
			(apply-safari-2.6 image 
                              txt-layer 
                              txt-layer 
                              bkg-layer 
                              type 
                              relief 
                              camo 
                              name 
                              light 
                              shadow 
                              blur 
                              elevation 
                              outline 
                              conserv)
			(set! list (cdr list))
                (set! frames (- frames 1))
                (gimp-displays-flush)                  
		)

          (gimp-image-remove-layer image bkg-layer)
          (gimp-image-remove-layer image txt-layer)
	)		
   )
   (if (= animate 2)
		(begin            
            (set! conserv FALSE)            
            (apply-safari-2.6 image txt-layer 
                                    txt-layer 
                                    bkg-layer 
                                    type 
                                    relief 
                                    camo 
                                    gradient 
                                    light 
                                    shadow 
                                    blur 
                                    elevation 
                                    outline 
                                    conserv)
           (gimp-image-merge-visible-layers image CLIP-TO-IMAGE)
           (set! activeLayer (car (gimp-image-get-active-layer image)))
           (script-fu-color-cycle image activeLayer frames)           
           (gimp-displays-flush)
           )
    )

   (gimp-image-undo-enable image)
(if (= animate 2)
  (begin                     
          (gimp-image-delete image)
  )
)

(if (= conserv TRUE) ;; Conserve the layers ?
  (begin                     
          (gimp-image-delete image)
  )
)
(if ( and (= conserv FALSE)(= animate 0));; Conserve the layers ?
  (begin                     
    (gimp-display-new image)      
  )
)
    
    
    ;;(gimp-image-delete image);;(gimp-display-new image)
    ;;(gimp-display-new image)
    (gimp-displays-flush)
    )
  ) 
(script-fu-register "script-fu-safari-2.6-logo"
  "Safari-Logo..."
  "Create an image with a text layer over a background layer"
  "Graechan"
  "Graechan"
  "03/09/2011"
  ""
  SF-STRING     "Tekst"               "Safari-2.6!"
  SF-FONT       "Czcionka"               "Sans Bold"
  SF-ADJUSTMENT "Rozmiar czcionki (px)" '(100 6 200 1 1 0 1)
  SF-OPTION "Tło typu" '("Bez tła" "Deseń" "Kolor")
  SF-PATTERN    "Deseń"            "Pink Marble"
  SF-COLOR      "Kolor"         '(153 153 153)
  SF-OPTION "Typ animacji" '("Brak" "Z wykorzystaniem gradientu" "Z wykorzystaniem koloru(odcień)")
  SF-ADJUSTMENT "Liczba ramek dla animacji" '(10 2 200 2 2 0 1)
  SF-OPTION "Typ" '("Quiet" "Wild" "Deep Cover" "Reptilian" "Peacefull")
  SF-OPTION "Wypukłość" '("Simple" "Double")
  SF-OPTION "Ustawienia camouflage" '("User Defined Gradient" "Desert" "Jungle" "Urban")
  SF-GRADIENT "Gradient użytkownika" "FG to BG (HSV counter-clockwise)"
  SF-OPTION "Intensywność światła" '("No Change""Dim" "Soft" "Medium" "Intense")
  SF-ADJUSTMENT "Cień" '(5 1 15 1 10 0 1)
  SF-ADJUSTMENT "Rozmycie(Bumpmap)" '(30 1 120 1 0 0 1)
  SF-ADJUSTMENT "Elevation(Bumpmap)" '(20 1 90 1 0 0 1)
  SF-ADJUSTMENT "Obrysowanie(0=bez zarysu)" '(1 0 5 1 0 0 1)		
  SF-TOGGLE "Zachować warstwy ?" FALSE
  )
(script-fu-menu-register "script-fu-safari-2.6-logo"
  "<Image>/File/Create/Logos"
  )


