; Snow Text rel 0.01
; Created by Graechan using methods described by Hea4ty at http://gimpchat.com/viewtopic.php?f=23&t=5818 
; 
; Comments directed to http://gimpchat.com or http://gimpscripts.com
;
; License: GPLv3
;    This program is free software: you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
;    GNU General Public License for more details.
;
;    To view a copy of the GNU General Public License
;    visit: http://www.gnu.org/licenses/gpl.html
;
;
; ------------
;| Change Log |
; ------------ 
; Rel 0.01 - Initial Release
;
(define (script-fu-snow-text 
                                      img-width
                                      img-height
                                      text 
                                      color 
                                      font-in 
                                      font-size
                                      bkg-type 
                                      pattern
                                      bkg-color
									  gradient
									  conserve
									  )
  (let* (
         (width img-width)
         (height img-height)
         (offx 0)
         (offy 0)
         (image (car (gimp-image-new img-width img-height RGB)))
         
         (border (/ font-size 4))
		 (font (if (> (string-length font-in) 0) font-in (car (gimp-context-get-font))))
         (text-layer (car (gimp-text-fontname image -1 0 0 text border TRUE font-size PIXELS font)))
         (text-width (car (gimp-drawable-width text-layer)))
         (text-height (car (gimp-drawable-height text-layer)))
         (bkg-layer 0)
		 (snow-layer 0)
		 (snowtop-layer 0)
		 (snowshadow-layer 0)
		 (ver 2.8)         
         )
	(cond ((not (defined? 'gimp-image-get-item-position)) (set! ver 2.6))) ;define the gimp version
	
    (gimp-context-push)
	(gimp-context-set-foreground '(0 0 0))
	(gimp-context-set-background '(255 255 255))
	
;;;;centre text on line
	(gimp-text-layer-set-justification text-layer 2)
;;;;set the new Image size
	(if (> text-width img-width) (set! width text-width))           
    (if (> text-height img-height) (set! height text-height))

;;;;square up the Image if needed	
    ;(if (< height width) (set! height width))
	;(if (< width height) (set! width height))

;;;;resize the image	
	(gimp-image-resize image width height 0 0)

	;;;;centre the text layer	
    (set! offx (/ (- width text-width) 2))
    (set! offy (/ (- height text-height) 2))    
    (gimp-layer-set-offsets text-layer offx offy)

;;;;set the text clolor    
    (gimp-context-set-foreground color)
	(gimp-selection-layer-alpha text-layer)
	(gimp-edit-fill text-layer FOREGROUND-FILL)
;	(gimp-selection-none image)
    
	(set! snow-layer (car (gimp-layer-new image width height RGBA-IMAGE "Snow Template" 100 NORMAL-MODE)))
    (gimp-image-add-layer image snow-layer -1)
	(gimp-edit-fill snow-layer BACKGROUND-FILL)
	(gimp-layer-set-offsets snow-layer 0 -10)
	(gimp-edit-clear snow-layer)
	(gimp-selection-none image)
	(gimp-selection-layer-alpha snow-layer)
	(script-fu-distress-selection image 
	                              snow-layer 
								  127       ;Threshold (bigger 1<-->255 smaller)
								  2         ;Spread (8 0 1000 1 10 0 1)
								  4         ;Granularity (1 is low) (4 1 25 1 10 0 1)
								  2         ;Smooth (2 1 150 1 10 0 1)
								  TRUE      ;Smooth horizontally TRUE
								  TRUE)     ;Smooth vertically TRUE
	(gimp-drawable-set-visible snow-layer FALSE)
	
	(set! snowtop-layer (car (gimp-layer-new image width height RGBA-IMAGE "Snow Topping" 100 NORMAL-MODE)))
    (gimp-image-add-layer image snowtop-layer -1)
	(gimp-context-set-background '(243 243 255))
	(gimp-edit-fill snowtop-layer BACKGROUND-FILL)
	(gimp-selection-none image)
	(plug-in-gauss-rle2 RUN-NONINTERACTIVE image snowtop-layer 3 3)
	(gimp-by-color-select snowtop-layer '(243 243 255) 25 2 TRUE FALSE 0 FALSE)
	(gimp-edit-fill snowtop-layer BACKGROUND-FILL)
	
	(set! snowshadow-layer (car (gimp-layer-new image width height RGBA-IMAGE "Snow Shadow" 100 NORMAL-MODE)))
    (gimp-image-add-layer image snowshadow-layer -1)
	(gimp-context-set-background '(149 149 207))
	(gimp-edit-fill snowshadow-layer BACKGROUND-FILL)
	(gimp-layer-set-offsets snowshadow-layer 0 5)
	(gimp-edit-clear snowshadow-layer)
	(gimp-layer-set-offsets snowshadow-layer 0 -1)
	(gimp-selection-invert image)
    (gimp-edit-clear snowshadow-layer)
	(gimp-selection-invert image)
	(plug-in-gauss-rle2 RUN-NONINTERACTIVE image snowshadow-layer 10 10)
	(gimp-selection-none image)
	(plug-in-gauss-rle2 RUN-NONINTERACTIVE image snowtop-layer 3 3)
	
;;;;create the background layer    
	(set! bkg-layer (car (gimp-layer-new image width height RGBA-IMAGE "Background" 100 NORMAL-MODE)))
    (gimp-image-add-layer image bkg-layer 4)
	(gimp-context-set-pattern pattern)
	(gimp-context-set-background bkg-color)
	(gimp-context-set-gradient gradient)
	(if (= bkg-type 1) (gimp-drawable-fill bkg-layer PATTERN-FILL))		
    (if (= bkg-type 2) (gimp-drawable-fill bkg-layer BACKGROUND-FILL))	
    (if (= bkg-type 3) (gimp-edit-blend bkg-layer CUSTOM-MODE NORMAL-MODE  GRADIENT-LINEAR 100 0 REPEAT-NONE FALSE FALSE 3 0.2 TRUE 0 0 width height));; GRADIENT-LINEAR ; GRADIENT-CONICAL-SYMMETRIC
    
	
	(if (= conserve FALSE) (begin
	(set! text-layer (car (gimp-image-merge-visible-layers image EXPAND-AS-NECESSARY)))snow-layer
	(gimp-image-remove-layer image snow-layer)
	)) ;endif
	(cond ((= ver 2.8) (gimp-item-set-name text-layer text))
	(else (gimp-drawable-set-name layer text-layer text))
    ) ;endcond
   
	
	
	
	

	(gimp-context-pop)
	    
    (gimp-display-new image)
    )
  ) 
(script-fu-register "script-fu-snow-text"
  "Snow Text..."
  "Create Snow covered text"
  "Graechan"
  "Graechan"
  "Dec 2013"
  ""
  SF-ADJUSTMENT "Image width (pixels)" '(512 1 1000 1 10 0 1)
  SF-ADJUSTMENT "Image height(pixels)" '(512 1 1000 1 10 0 1)
  SF-TEXT       "Text"    "SEASONS\nGREETINGS"
  SF-COLOR      "Text color"         '(139 0 0)
  SF-FONT       "Font"               "Sans Bold"
  SF-ADJUSTMENT "Font size (pixels)" '(150 6 500 1 1 0 1)
  SF-OPTION "Background Type" '("None" "Pattern" "Color" "Gradient")
  SF-PATTERN    "Pattern"            "Pink Marble"
  SF-COLOR      "Background color"         '(0 0 0)
  SF-GRADIENT   "Background Gradient" "Abstract 3"
  SF-TOGGLE     "Keep the Layers"   FALSE
  )
(script-fu-menu-register "script-fu-snow-text" "<Image>/File/Create/Logos"
  )